Index: src/AST/Type.hpp
===================================================================
--- src/AST/Type.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/Type.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -36,4 +36,6 @@
 
 template< typename T > class Pass;
+
+struct ForallSubstitutor;
 
 class Type : public Node {
@@ -270,9 +272,10 @@
 /// Type of a function `[R1, R2](*)(P1, P2, P3)`
 class FunctionType final : public Type {
-public:
-	using ForallList = std::vector<ptr<TypeInstType>>;
-	using AssertionList = std::vector<ptr<VariableExpr>>;
+	protected:
+	/// initializes forall with substitutor
+	void initWithSub( const FunctionType & o, Pass< ForallSubstitutor > & sub );
+public:
+	using ForallList = std::vector<ptr<TypeDecl>>;
 	ForallList forall;
-	AssertionList assertions;
 
 	std::vector<ptr<Type>> returns;
@@ -289,5 +292,5 @@
 	: Type(q), returns(), params(), isVarArgs(va) {}
 
-	FunctionType( const FunctionType & o ) = default;
+	FunctionType( const FunctionType & o );
 
 	/// true if either the parameters or return values contain a tttype
@@ -394,26 +397,5 @@
 public:
 	readonly<TypeDecl> base;
-	// previously from renameTyVars; now directly use integer fields instead of synthesized strings
-	// a nonzero value of formal_usage indicates a formal type (only used in function type)
-	// a zero value of formal_usage indicates an actual type (referenced inside body of parametric structs and functions)
 	TypeDecl::Kind kind;
-	int formal_usage = 0;
-	int expr_id = 0;
-
-	// compact representation used for map lookups.
-	struct TypeEnvKey { 
-		const TypeDecl * base;
-		int formal_usage;
-		int expr_id;
-
-		TypeEnvKey() = default;
-		TypeEnvKey(const TypeDecl * base, int formal_usage = 0, int expr_id = 0): base(base), formal_usage(formal_usage), expr_id(expr_id) {}
-		TypeEnvKey(const TypeInstType & inst): base(inst.base), formal_usage(inst.formal_usage), expr_id(inst.expr_id) {}
-		std::string typeString() const { return std::string("_") + std::to_string(formal_usage) + "_" + std::to_string(expr_id) + "_" + base->name; }
-		bool operator==(const TypeEnvKey & other) const { return base == other.base && formal_usage == other.formal_usage && expr_id == other.expr_id; }
-
-	};
-
-	bool operator==(const TypeInstType & other) const { return base == other.base && formal_usage == other.formal_usage && expr_id == other.expr_id; }
 
 	TypeInstType(
@@ -427,7 +409,4 @@
 	TypeInstType( const TypeInstType & o ) = default;
 
-	TypeInstType( const TypeEnvKey & key )
-	: BaseInstType(key.base->name), base(key.base), kind(key.base->kind), formal_usage(key.formal_usage), expr_id(key.expr_id) {}
-
 	/// sets `base`, updating `kind` correctly
 	void set_base( const TypeDecl * );
@@ -439,9 +418,4 @@
 
 	const Type * accept( Visitor & v ) const override { return v.visit( this ); }
-
-	std::string typeString() const { 
-		if (formal_usage > 0) return std::string("_") + std::to_string(formal_usage) + "_" + std::to_string(expr_id) + "_" + name; 
-		else return name;
-	}
 private:
 	TypeInstType * clone() const override { return new TypeInstType{ *this }; }
@@ -536,18 +510,6 @@
 
 bool isUnboundType(const Type * type);
-
-}
-
-namespace std {
-	template<>
-	struct hash<typename ast::TypeInstType::TypeEnvKey> {
-		size_t operator() (const ast::TypeInstType::TypeEnvKey & x) const {
-			const size_t p = 1000007;
-			size_t res = reinterpret_cast<size_t>(x.base);
-			res = p * res + x.formal_usage;
-			res = p * res + x.expr_id;
-			return res;
-		} 
-	};
+bool isUnboundType(const std::string & tname);
+
 }
 
Index: src/AST/TypeEnvironment.cpp
===================================================================
--- src/AST/TypeEnvironment.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/TypeEnvironment.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -52,5 +52,5 @@
 	for ( const auto & i : open ) {
 		if ( first ) { first = false; } else { out << ' '; }
-		out << i.first.typeString() << "(" << i.second << ")";
+		out << i.first << "(" << i.second << ")";
 	}
 }
@@ -62,9 +62,6 @@
 		if(first) first = false;
 		else out << " ";
-
-		if( deterministic_output ) out << "[unbound]";
-		else out << "_" << var.formal_usage << "_" << var.expr_id << "_";
-
-		out << var.base->name;
+		if( deterministic_output && isUnboundType(var) ) out << "[unbound]";
+		else out << var;
 	}
 	out << ")";
@@ -82,5 +79,5 @@
 }
 
-const EqvClass * TypeEnvironment::lookup( const TypeInstType::TypeEnvKey & var ) const {
+const EqvClass * TypeEnvironment::lookup( const std::string & var ) const {
 	for ( ClassList::const_iterator i = env.begin(); i != env.end(); ++i ) {
 		if ( i->vars.find( var ) != i->vars.end() ) return &*i;
@@ -109,5 +106,5 @@
 
 void TypeEnvironment::add( const FunctionType::ForallList & tyDecls ) {
-	for ( auto & tyDecl : tyDecls ) {
+	for ( const TypeDecl * tyDecl : tyDecls ) {
 		env.emplace_back( tyDecl );
 	}
@@ -122,14 +119,12 @@
 void TypeEnvironment::writeToSubstitution( TypeSubstitution & sub ) const {
 	for ( const auto & clz : env ) {
-		TypeInstType::TypeEnvKey clzRep;
-		bool first = true;
+		std::string clzRep;
 		for ( const auto & var : clz.vars ) {
 			if ( clz.bound ) {
 				sub.add( var, clz.bound );
-			} else if ( first ) {
+			} else if ( clzRep.empty() ) {
 				clzRep = var;
-				first = false;
 			} else {
-				sub.add( var, new TypeInstType{ clzRep } );
+				sub.add( var, new TypeInstType{ clzRep, clz.data.kind } );
 			}
 		}
@@ -146,8 +141,8 @@
 	struct Occurs : public ast::WithVisitorRef<Occurs> {
 		bool result;
-		std::unordered_set< TypeInstType::TypeEnvKey > vars;
+		std::set< std::string > vars;
 		const TypeEnvironment & tenv;
 
-		Occurs( const TypeInstType::TypeEnvKey & var, const TypeEnvironment & env )
+		Occurs( const std::string & var, const TypeEnvironment & env )
 		: result( false ), vars(), tenv( env ) {
 			if ( const EqvClass * clz = tenv.lookup( var ) ) {
@@ -159,7 +154,7 @@
 
 		void previsit( const TypeInstType * typeInst ) {
-			if ( vars.count( *typeInst ) ) {
+			if ( vars.count( typeInst->name ) ) {
 				result = true;
-			} else if ( const EqvClass * clz = tenv.lookup( *typeInst ) ) {
+			} else if ( const EqvClass * clz = tenv.lookup( typeInst->name ) ) {
 				if ( clz->bound ) {
 					clz->bound->accept( *visitor );
@@ -170,5 +165,5 @@
 
 	/// true if `var` occurs in `ty` under `env`
-	bool occurs( const Type * ty, const TypeInstType::TypeEnvKey & var, const TypeEnvironment & env ) {
+	bool occurs( const Type * ty, const std::string & var, const TypeEnvironment & env ) {
 		Pass<Occurs> occur{ var, env };
 		maybe_accept( ty, occur );
@@ -285,10 +280,10 @@
 	// remove references from bound type, so that type variables can only bind to value types
 	ptr<Type> target = bindTo->stripReferences();
-	auto tyvar = open.find( *typeInst );
+	auto tyvar = open.find( typeInst->name );
 	assert( tyvar != open.end() );
 	if ( ! tyVarCompatible( tyvar->second, target ) ) return false;
-	if ( occurs( target, *typeInst, *this ) ) return false;
-
-	auto it = internal_lookup( *typeInst );
+	if ( occurs( target, typeInst->name, *this ) ) return false;
+
+	auto it = internal_lookup( typeInst->name );
 	if ( it != env.end() ) {
 		if ( it->bound ) {
@@ -313,5 +308,5 @@
 	} else {
 		env.emplace_back(
-			*typeInst, target, widen.first && widen.second, data );
+			typeInst->name, target, widen.first && widen.second, data );
 	}
 	return true;
@@ -323,6 +318,6 @@
 		WidenMode widen, const SymbolTable & symtab
 ) {
-	auto c1 = internal_lookup( *var1 );
-	auto c2 = internal_lookup( *var2 );
+	auto c1 = internal_lookup( var1->name );
+	auto c2 = internal_lookup( var2->name );
 
 	// exit early if variables already bound together
@@ -338,5 +333,5 @@
 	if ( c1 != env.end() ) {
 		if ( c1->bound ) {
-			if ( occurs( c1->bound, *var2, *this ) ) return false;
+			if ( occurs( c1->bound, var2->name, *this ) ) return false;
 			type1 = c1->bound;
 		}
@@ -345,5 +340,5 @@
 	if ( c2 != env.end() ) {
 		if ( c2->bound ) {
-			if ( occurs( c2->bound, *var1, *this ) ) return false;
+			if ( occurs( c2->bound, var1->name, *this ) ) return false;
 			type2 = c2->bound;
 		}
@@ -383,15 +378,15 @@
 	} else if ( c1 != env.end() ) {
 		// var2 unbound, add to env[c1]
-		c1->vars.emplace( *var2 );
+		c1->vars.emplace( var2->name );
 		c1->allowWidening = widen1;
 		c1->data.isComplete |= data.isComplete;
 	} else if ( c2 != env.end() ) {
 		// var1 unbound, add to env[c2]
-		c2->vars.emplace( *var1 );
+		c2->vars.emplace( var1->name );
 		c2->allowWidening = widen2;
 		c2->data.isComplete |= data.isComplete;
 	} else {
 		// neither var bound, create new class
-		env.emplace_back( *var1, *var2, widen1 && widen2, data );
+		env.emplace_back( var1->name, var2->name, widen1 && widen2, data );
 	}
 
@@ -457,5 +452,5 @@
 }
 
-TypeEnvironment::ClassList::iterator TypeEnvironment::internal_lookup( const TypeInstType::TypeEnvKey & var ) {
+TypeEnvironment::ClassList::iterator TypeEnvironment::internal_lookup( const std::string & var ) {
 	for ( ClassList::iterator i = env.begin(); i != env.end(); ++i ) {
 		if ( i->vars.count( var ) ) return i;
Index: src/AST/TypeEnvironment.hpp
===================================================================
--- src/AST/TypeEnvironment.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/TypeEnvironment.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -55,7 +55,7 @@
 /// recorded. More investigation is needed.
 struct AssertCompare {
-	bool operator()( const VariableExpr * d1, const VariableExpr * d2 ) const {
-		int cmp = d1->var->name.compare( d2->var->name );
-		return cmp < 0 || ( cmp == 0 && d1->result < d2->result );
+	bool operator()( const DeclWithType * d1, const DeclWithType * d2 ) const {
+		int cmp = d1->name.compare( d2->name );
+		return cmp < 0 || ( cmp == 0 && d1->get_type() < d2->get_type() );
 	}
 };
@@ -70,8 +70,8 @@
 
 /// Set of assertions pending satisfaction
-using AssertionSet = std::map< const VariableExpr *, AssertionSetValue, AssertCompare >;
+using AssertionSet = std::map< readonly<DeclWithType>, AssertionSetValue, AssertCompare >;
 
 /// Set of open variables
-using OpenVarSet = std::unordered_map< TypeInstType::TypeEnvKey, TypeDecl::Data >;
+using OpenVarSet = std::unordered_map< std::string, TypeDecl::Data >;
 
 /// Merges one set of open vars into another
@@ -89,5 +89,5 @@
 /// they bind to.
 struct EqvClass {
-	std::unordered_set< TypeInstType::TypeEnvKey > vars;
+	std::set< std::string > vars;
 	ptr<Type> bound;
 	bool allowWidening;
@@ -101,13 +101,13 @@
 
 	/// Singleton class constructor from TypeDecl
-	EqvClass( const TypeInstType * inst )
-	: vars{ *inst }, bound(), allowWidening( true ), data( inst->base ) {}
+	EqvClass( const TypeDecl * decl )
+	: vars{ decl->name }, bound(), allowWidening( true ), data( decl ) {}
 
 	/// Singleton class constructor from substitution
-	EqvClass( const TypeInstType::TypeEnvKey & v, const Type * b )
+	EqvClass( const std::string & v, const Type * b )
 	: vars{ v }, bound( b ), allowWidening( false ), data( TypeDecl::Dtype, false ) {}
 
 	/// Single-var constructor (strips qualifiers from bound type)
-	EqvClass( const TypeInstType::TypeEnvKey & v, const Type * b, bool w, const TypeDecl::Data & d )
+	EqvClass( const std::string & v, const Type * b, bool w, const TypeDecl::Data & d )
 	: vars{ v }, bound( b ), allowWidening( w ), data( d ) {
 		reset_qualifiers( bound );
@@ -115,5 +115,5 @@
 
 	/// Double-var constructor
-	EqvClass( const TypeInstType::TypeEnvKey & v, const TypeInstType::TypeEnvKey & u, bool w, const TypeDecl::Data & d )
+	EqvClass( const std::string & v, const std::string & u, bool w, const TypeDecl::Data & d )
 	: vars{ v, u }, bound(), allowWidening( w ), data( d ) {}
 
@@ -131,5 +131,5 @@
 public:
 	/// Finds the equivalence class containing a variable; nullptr for none such
-	const EqvClass * lookup( const TypeInstType::TypeEnvKey & var ) const;
+	const EqvClass * lookup( const std::string & var ) const;
 
 	/// Add a new equivalence class for each type variable
@@ -207,5 +207,5 @@
 
 	/// Private lookup API; returns array index of string, or env.size() for not found
-	ClassList::iterator internal_lookup( const TypeInstType::TypeEnvKey & );
+	ClassList::iterator internal_lookup( const std::string & );
 };
 
Index: src/AST/TypeSubstitution.cpp
===================================================================
--- src/AST/TypeSubstitution.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/TypeSubstitution.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -39,4 +39,5 @@
 void TypeSubstitution::initialize( const TypeSubstitution &src, TypeSubstitution &dest ) {
 	dest.typeEnv.clear();
+	dest.varEnv.clear();
 	dest.add( src );
 }
@@ -46,23 +47,26 @@
 		typeEnv[ i->first ] = i->second;
 	} // for
-}
-
-void TypeSubstitution::add( const TypeInstType * formalType, const Type *actualType ) {
-	typeEnv[ *formalType ] = actualType;
-}
-
-void TypeSubstitution::add( const TypeInstType::TypeEnvKey & key, const Type * actualType) {
-	typeEnv[ key ] = actualType;
-}
-
-void TypeSubstitution::remove( const TypeInstType * formalType ) {
-	TypeEnvType::iterator i = typeEnv.find( *formalType );
+	for ( VarEnvType::const_iterator i = other.varEnv.begin(); i != other.varEnv.end(); ++i ) {
+		varEnv[ i->first ] = i->second;
+	} // for
+}
+
+void TypeSubstitution::add( std::string formalType, const Type *actualType ) {
+	typeEnv[ formalType ] = actualType;
+}
+
+void TypeSubstitution::addVar( std::string formalExpr, const Expr *actualExpr ) {
+	varEnv[ formalExpr ] = actualExpr;
+}
+
+void TypeSubstitution::remove( std::string formalType ) {
+	TypeEnvType::iterator i = typeEnv.find( formalType );
 	if ( i != typeEnv.end() ) {
-		typeEnv.erase( *formalType );
-	} // if
-}
-
-const Type *TypeSubstitution::lookup( const TypeInstType * formalType ) const {
-	TypeEnvType::const_iterator i = typeEnv.find( *formalType );
+		typeEnv.erase( formalType );
+	} // if
+}
+
+const Type *TypeSubstitution::lookup( std::string formalType ) const {
+	TypeEnvType::const_iterator i = typeEnv.find( formalType );
 
 	// break on not in substitution set
@@ -71,9 +75,11 @@
 	// attempt to transitively follow TypeInstType links.
 	while ( const TypeInstType *actualType = i->second.as<TypeInstType>()) {
+		const std::string& typeName = actualType->name;
+
 		// break cycles in the transitive follow
-		if ( *formalType == *actualType ) break;
+		if ( formalType == typeName ) break;
 
 		// Look for the type this maps to, returning previous mapping if none-such
-		i = typeEnv.find( *actualType );
+		i = typeEnv.find( typeName );
 		if ( i == typeEnv.end() ) return actualType;
 	}
@@ -84,5 +90,5 @@
 
 bool TypeSubstitution::empty() const {
-	return typeEnv.empty();
+	return typeEnv.empty() && varEnv.empty();
 }
 
@@ -92,10 +98,8 @@
 		TypeSubstitution * newEnv;
 		EnvTrimmer( const TypeSubstitution * env, TypeSubstitution * newEnv ) : env( env ), newEnv( newEnv ){}
-		void previsit( FunctionType * ftype ) {
+		void previsit( TypeDecl * tyDecl ) {
 			// transfer known bindings for seen type variables
-			for (auto & formal : ftype->forall) {
-				if ( const Type * t = env->lookup( formal ) ) {
-					newEnv->add( formal, t );
-				}
+			if ( const Type * t = env->lookup( tyDecl->name ) ) {
+				newEnv->add( tyDecl->name, t );
 			}
 		}
@@ -126,8 +130,8 @@
 
 const Type * TypeSubstitution::Substituter::postvisit( const TypeInstType *inst ) {
-	BoundVarsType::const_iterator bound = boundVars.find( *inst );
+	BoundVarsType::const_iterator bound = boundVars.find( inst->name );
 	if ( bound != boundVars.end() ) return inst;
 
-	TypeEnvType::const_iterator i = sub.typeEnv.find( *inst );
+	TypeEnvType::const_iterator i = sub.typeEnv.find( inst->name );
 	if ( i == sub.typeEnv.end() ) {
 		return inst;
@@ -137,5 +141,5 @@
 		// TODO: investigate preventing type variables from being bound to themselves in the first place.
 		if ( const TypeInstType * replacement = i->second.as<TypeInstType>() ) {
-			if ( *inst == *replacement ) {
+			if ( inst->name == replacement->name ) {
 				return inst;
 			}
@@ -152,15 +156,24 @@
 }
 
+const Expr * TypeSubstitution::Substituter::postvisit( const NameExpr * nameExpr ) {
+	VarEnvType::const_iterator i = sub.varEnv.find( nameExpr->name );
+	if ( i == sub.varEnv.end() ) {
+		return nameExpr;
+	} else {
+		subCount++;
+		return i->second;
+	} // if
+}
+
 void TypeSubstitution::Substituter::previsit( const FunctionType * ptype ) {
 	GuardValue( boundVars );
 	// bind type variables from forall-qualifiers
 	if ( freeOnly ) {
-		for ( auto & tyvar : ptype->forall ) {
-				boundVars.insert( *tyvar );
+		for ( const TypeDecl * tyvar : ptype->forall ) {
+				boundVars.insert( tyvar->name );
 		} // for
 	} // if
 }
 
-/*
 void TypeSubstitution::Substituter::handleAggregateType( const BaseInstType * type ) {
 	GuardValue( boundVars );
@@ -171,5 +184,5 @@
 			if ( ! type->params.empty() ) {
 				for ( const TypeDecl * tyvar : decl->params ) {
-					boundVars.insert( *tyvar );
+					boundVars.insert( tyvar->name );
 				} // for
 			} // if
@@ -185,5 +198,4 @@
 	handleAggregateType( aggregateUseType );
 }
-*/
 
 } // namespace ast
Index: src/AST/TypeSubstitution.hpp
===================================================================
--- src/AST/TypeSubstitution.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/TypeSubstitution.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -69,10 +69,11 @@
 	}
 
-	void add( const TypeInstType * formalType, const Type *actualType );
-	void add( const TypeInstType::TypeEnvKey & key, const Type *actualType );
+	void add( std::string formalType, const Type *actualType );
 	void add( const TypeSubstitution &other );
-	void remove( const TypeInstType * formalType );
-	const Type *lookup( const TypeInstType * formalType ) const;
+	void remove( std::string formalType );
+	const Type *lookup( std::string formalType ) const;
 	bool empty() const;
+
+	void addVar( std::string formalExpr, const Expr *actualExpr );
 
 	template< typename FormalIterator, typename ActualIterator >
@@ -100,6 +101,8 @@
 	friend class Pass;
 
-	typedef std::unordered_map< TypeInstType::TypeEnvKey, ptr<Type> > TypeEnvType;
+	typedef std::unordered_map< std::string, ptr<Type> > TypeEnvType;
+	typedef std::unordered_map< std::string, ptr<Expr> > VarEnvType;
 	TypeEnvType typeEnv;
+	VarEnvType varEnv;
 
   public:
@@ -110,7 +113,10 @@
 	auto   end() const -> decltype( typeEnv.  end() ) { return typeEnv.  end(); }
 
+	auto beginVar()       -> decltype( varEnv.begin() ) { return varEnv.begin(); }
+	auto   endVar()       -> decltype( varEnv.  end() ) { return varEnv.  end(); }
+	auto beginVar() const -> decltype( varEnv.begin() ) { return varEnv.begin(); }
+	auto   endVar() const -> decltype( varEnv.  end() ) { return varEnv.  end(); }
 };
 
-// this is the only place where type parameters outside a function formal may be substituted.
 template< typename FormalIterator, typename ActualIterator >
 void TypeSubstitution::add( FormalIterator formalBegin, FormalIterator formalEnd, ActualIterator actualBegin ) {
@@ -123,5 +129,5 @@
 			if ( const TypeExpr *actual = actualIt->template as<TypeExpr>() ) {
 				if ( formal->name != "" ) {
-					typeEnv[ formal ] = actual->type;
+					typeEnv[ formal->name ] = actual->type;
 				} // if
 			} else {
@@ -129,10 +135,11 @@
 			} // if
 		} else {
-			
+			// TODO: type check the formal and actual parameters
+			if ( (*formalIt)->name != "" ) {
+				varEnv[ (*formalIt)->name ] = *actualIt;
+			} // if
 		} // if
 	} // for
 }
-
-
 
 template< typename FormalIterator, typename ActualIterator >
@@ -140,5 +147,4 @@
 	add( formalBegin, formalEnd, actualBegin );
 }
-
 
 } // namespace ast
@@ -158,17 +164,18 @@
 
 		const Type * postvisit( const TypeInstType * aggregateUseType );
+		const Expr * postvisit( const NameExpr * nameExpr );
 
 		/// Records type variable bindings from forall-statements
 		void previsit( const FunctionType * type );
 		/// Records type variable bindings from forall-statements and instantiations of generic types
-		// void handleAggregateType( const BaseInstType * type );
-
-		// void previsit( const StructInstType * aggregateUseType );
-		// void previsit( const UnionInstType * aggregateUseType );
+		void handleAggregateType( const BaseInstType * type );
+
+		void previsit( const StructInstType * aggregateUseType );
+		void previsit( const UnionInstType * aggregateUseType );
 
 		const TypeSubstitution & sub;
 		int subCount = 0;
 		bool freeOnly;
-		typedef std::unordered_set< TypeInstType::TypeEnvKey > BoundVarsType;
+		typedef std::unordered_set< std::string > BoundVarsType;
 		BoundVarsType boundVars;
 
Index: src/AST/module.mk
===================================================================
--- src/AST/module.mk	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/AST/module.mk	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -33,4 +33,7 @@
 	AST/Expr.cpp \
 	AST/Expr.hpp \
+	AST/ForallSubstitutionTable.cpp \
+	AST/ForallSubstitutionTable.hpp \
+	AST/ForallSubstitutor.hpp \
 	AST/FunctionSpec.hpp \
 	AST/Fwd.hpp \
Index: src/GenPoly/GenPoly.cc
===================================================================
--- src/GenPoly/GenPoly.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/GenPoly/GenPoly.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -115,5 +115,5 @@
 		if (!env) return type;
 		if (auto typeInst = dynamic_cast<const ast::TypeInstType*> (type)) {
-			auto newType = env->lookup(typeInst);
+			auto newType = env->lookup(typeInst->name);
 			if (newType) return newType;
 		}
@@ -172,5 +172,5 @@
 
 		if ( auto typeInst = dynamic_cast< const ast::TypeInstType * >( type ) ) {
-			return tyVars.find(typeInst->typeString()) != tyVars.end() ? type : nullptr;
+			return tyVars.find(typeInst->name) != tyVars.end() ? type : nullptr;
 		} else if ( auto arrayType = dynamic_cast< const ast::ArrayType * >( type ) ) {
 			return isPolyType( arrayType->base, env );
@@ -552,6 +552,6 @@
 	}
 
-	void addToTyVarMap( const ast::TypeInstType * tyVar, TyVarMap & tyVarMap) {
-		tyVarMap.insert(tyVar->typeString(), convData(ast::TypeDecl::Data{tyVar->base}));
+	void addToTyVarMap( const ast::TypeDecl * tyVar, TyVarMap & tyVarMap) {
+		tyVarMap.insert(tyVar->name, convData(ast::TypeDecl::Data{tyVar}));
 	}
 
Index: src/InitTweak/GenInit.cc
===================================================================
--- src/InitTweak/GenInit.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/InitTweak/GenInit.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -122,32 +122,6 @@
 	};
 
-	struct HoistArrayDimension_NoResolve final : public WithDeclsToAdd, public WithShortCircuiting, public WithGuards {
-		/// hoist dimension from array types in object declaration so that it uses a single
-		/// const variable of type size_t, so that side effecting array dimensions are only
-		/// computed once.
-		static void hoistArrayDimension( std::list< Declaration * > & translationUnit );
-
-		void premutate( ObjectDecl * objectDecl );
-		DeclarationWithType * postmutate( ObjectDecl * objectDecl );
-		void premutate( FunctionDecl *functionDecl );
-		// should not traverse into any of these declarations to find objects
-		// that need to be constructed or destructed
-		void premutate( AggregateDecl * ) { visit_children = false; }
-		void premutate( NamedTypeDecl * ) { visit_children = false; }
-		void premutate( FunctionType * ) { visit_children = false; }
-
-		void hoist( Type * type );
-
-		Type::StorageClasses storageClasses;
-		bool inFunction = false;
-	};
-
 	void genInit( std::list< Declaration * > & translationUnit ) {
-		if (!useNewAST) {
-			HoistArrayDimension::hoistArrayDimension( translationUnit );
-		}
-		else {
-			HoistArrayDimension_NoResolve::hoistArrayDimension( translationUnit );
-		}
+		HoistArrayDimension::hoistArrayDimension( translationUnit );
 		fixReturnStatements( translationUnit );
 
@@ -222,7 +196,9 @@
 
 			// need to resolve array dimensions in order to accurately determine if constexpr
-			ResolvExpr::findSingleExpression( arrayType->dimension, Validate::SizeType->clone(), indexer );
-			// array is variable-length when the dimension is not constexpr
-			arrayType->isVarLen = ! isConstExpr( arrayType->dimension );
+			if (!useNewAST) {
+				ResolvExpr::findSingleExpression( arrayType->dimension, Validate::SizeType->clone(), indexer );
+				// array is variable-length when the dimension is not constexpr
+				arrayType->isVarLen = ! isConstExpr( arrayType->dimension );
+			}
 			// don't need to hoist dimension if it's definitely pure - only need to if there's potential for side effects.
 			// xxx - hoisting has no side effects anyways, so don't skip since we delay resolve
@@ -242,52 +218,4 @@
 
 	void HoistArrayDimension::premutate( FunctionDecl * ) {
-		GuardValue( inFunction );
-		inFunction = true;
-	}
-
-	// precompute array dimension expression, because constructor generation may duplicate it,
-	// which would be incorrect if it is a side-effecting computation.
-	void HoistArrayDimension_NoResolve::hoistArrayDimension( std::list< Declaration * > & translationUnit ) {
-		PassVisitor<HoistArrayDimension_NoResolve> hoister;
-		mutateAll( translationUnit, hoister );
-	}
-
-	void HoistArrayDimension_NoResolve::premutate( ObjectDecl * objectDecl ) {
-		GuardValue( storageClasses );
-		storageClasses = objectDecl->get_storageClasses();
-	}
-
-	DeclarationWithType * HoistArrayDimension_NoResolve::postmutate( ObjectDecl * objectDecl ) {
-		hoist( objectDecl->get_type() );
-		return objectDecl;
-	}
-
-	void HoistArrayDimension_NoResolve::hoist( Type * type ) {
-		// if in function, generate const size_t var
-		static UniqueName dimensionName( "_array_dim" );
-
-		// C doesn't allow variable sized arrays at global scope or for static variables, so don't hoist dimension.
-		if ( ! inFunction ) return;
-		if ( storageClasses.is_static ) return;
-
-		if ( ArrayType * arrayType = dynamic_cast< ArrayType * >( type ) ) {
-			if ( ! arrayType->get_dimension() ) return; // xxx - recursive call to hoist?
-			// don't need to hoist dimension if it's definitely pure - only need to if there's potential for side effects.
-			// xxx - hoisting has no side effects anyways, so don't skip since we delay resolve
-			// still try to detect constant expressions
-			if ( ! Tuples::maybeImpure( arrayType->dimension ) ) return;
-
-			ObjectDecl * arrayDimension = new ObjectDecl( dimensionName.newName(), storageClasses, LinkageSpec::C, 0, Validate::SizeType->clone(), new SingleInit( arrayType->get_dimension() ) );
-			arrayDimension->get_type()->set_const( true );
-
-			arrayType->set_dimension( new VariableExpr( arrayDimension ) );
-			declsToAddBefore.push_back( arrayDimension );
-
-			hoist( arrayType->get_base() );
-			return;
-		}
-	}
-
-	void HoistArrayDimension_NoResolve::premutate( FunctionDecl * ) {
 		GuardValue( inFunction );
 		inFunction = true;
Index: src/ResolvExpr/AdjustExprType.cc
===================================================================
--- src/ResolvExpr/AdjustExprType.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/AdjustExprType.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -133,5 +133,5 @@
 		const ast::Type * postvisit( const ast::TypeInstType * inst ) {
 			// replace known function-type-variables with pointer-to-function
-			if ( const ast::EqvClass * eqvClass = tenv.lookup( *inst ) ) {
+			if ( const ast::EqvClass * eqvClass = tenv.lookup( inst->name ) ) {
 				if ( eqvClass->data.kind == ast::TypeDecl::Ftype ) {
 					return new ast::PointerType{ inst };
Index: src/ResolvExpr/CandidateFinder.cpp
===================================================================
--- src/ResolvExpr/CandidateFinder.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/CandidateFinder.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -212,5 +212,7 @@
 		// mark type variable and specialization cost of forall clause
 		convCost.incVar( function->forall.size() );
-		convCost.decSpec( function->assertions.size() );
+		for ( const ast::TypeDecl * td : function->forall ) {
+			convCost.decSpec( td->assertions.size() );
+		}
 
 		return convCost;
@@ -221,9 +223,9 @@
 		ast::AssertionSet & need
 	) {
-		for ( auto & tyvar : type->forall ) {
-			unifiableVars[ *tyvar ] = ast::TypeDecl::Data{ tyvar->base };
-		}
-		for ( auto & assn : type->assertions ) {
-			need[ assn ].isUsed = true;
+		for ( const ast::TypeDecl * tyvar : type->forall ) {
+			unifiableVars[ tyvar->name ] = ast::TypeDecl::Data{ tyvar };
+			for ( const ast::DeclWithType * assn : tyvar->assertions ) {
+				need[ assn ].isUsed = true;
+			}
 		}
 	}
@@ -905,10 +907,5 @@
 			// xxx - is it possible that handleTupleAssignment and main finder both produce candidates?
 			// this means there exists ctor/assign functions with a tuple as first parameter.
-			ResolvMode mode = {
-				true, // adjust
-				!untypedExpr->func.as<ast::NameExpr>(), // prune if not calling by name
-				selfFinder.candidates.empty() // failfast if other options are not found
-			};
-			funcFinder.find( untypedExpr->func, mode );
+			funcFinder.find( untypedExpr->func, selfFinder.candidates.empty() ? ResolvMode::withAdjustment() : ResolvMode::withoutFailFast() );
 			// short-circuit if no candidates
 			// if ( funcFinder.candidates.empty() ) return;
@@ -956,5 +953,5 @@
 						auto inst = dynamic_cast< const ast::TypeInstType * >( funcResult )
 					) {
-						if ( const ast::EqvClass * clz = func->env.lookup( *inst ) ) {
+						if ( const ast::EqvClass * clz = func->env.lookup( inst->name ) ) {
 							if ( auto function = clz->bound.as< ast::FunctionType >() ) {
 								CandidateRef newFunc{ new Candidate{ *func } };
@@ -1080,5 +1077,5 @@
 			assert( toType );
 			toType = resolveTypeof( toType, symtab );
-			// toType = SymTab::validateType( castExpr->location, toType, symtab );
+			toType = SymTab::validateType( castExpr->location, toType, symtab );
 			toType = adjustExprType( toType, tenv, symtab );
 
@@ -1165,5 +1162,5 @@
 
 					if(auto insttype = dynamic_cast<const ast::TypeInstType*>(expr)) {
-						auto td = cand->env.lookup(*insttype);
+						auto td = cand->env.lookup(insttype->name);
 						if(!td) { continue; }
 						expr = td->bound.get();
@@ -1571,5 +1568,5 @@
 				// calculate target type
 				const ast::Type * toType = resolveTypeof( initAlt.type, symtab );
-				// toType = SymTab::validateType( initExpr->location, toType, symtab );
+				toType = SymTab::validateType( initExpr->location, toType, symtab );
 				toType = adjustExprType( toType, tenv, symtab );
 				// The call to find must occur inside this loop, otherwise polymorphic return
Index: src/ResolvExpr/CastCost.cc
===================================================================
--- src/ResolvExpr/CastCost.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/CastCost.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -202,5 +202,5 @@
 ) {
 	if ( auto typeInst = dynamic_cast< const ast::TypeInstType * >( dst ) ) {
-		if ( const ast::EqvClass * eqvClass = env.lookup( *typeInst ) ) {
+		if ( const ast::EqvClass * eqvClass = env.lookup( typeInst->name ) ) {
 			// check cast cost against bound type, if present
 			if ( eqvClass->bound ) {
